local frame = CreateFrame ("Frame")
if not frame then return end

-- Convenient alias for our saved state table
local state = nil

-- Cache the build info
local ver, rev, date, uiver = GetBuildInfo ()

-- CVar
local cvar = "checkAddonVersion"

local function MarkRevisionHandled ()
  if not state then return end
  state.last_rev = rev
end

local function LoadOutOfDateAddons ()
  SetCVar (cvar, "0")
  MarkRevisionHandled ()
  ReloadUI ()
end

local function AskUser ()
  local TAG = "out_of_date_minder_popup"
  if not StaticPopupDialogs[TAG] then
    StaticPopupDialogs[TAG] = {
      text = '|cffff2200Out Of Date Minder|r\n\nOut of date AddOns have NOT been loaded.\n\nDo you want to load them now?',
      button1 = "Yes",
      button2 = "No",
      OnAccept = LoadOutOfDateAddons,
      OnCancel = MarkRevisionHandled,
      timeout = 0,
      whileDead = true,
      hideOnEscape = false,
    }
  end
  StaticPopup_Show(TAG)
end

function frame:OnEvent (event, arg1, ...)
  if event == "ADDON_LOADED" then
    if arg1 == "out_of_date_minder" then
      if not OutOfDateMinderState then
        OutOfDateMinderState = { last_rev = 0 }
      end
      state = OutOfDateMinderState
    end
  elseif event == "PLAYER_LOGIN" then
     local cav = GetCVar (cvar) or 0
     if cav == "1" and rev ~= state.last_rev then
        AskUser ()
     end
  end
end
frame:SetScript("OnEvent", frame.OnEvent)

frame:RegisterEvent ("ADDON_LOADED")
frame:RegisterEvent ("PLAYER_LOGIN")

SLASH_OUTOFDATEMINDER1 = "/oodm"
SlashCmdList.OUTOFDATEMINDER = LoadOutOfDateAddons

